"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = handleRefLabel;

var _types = require("@babel/types");

var _utils = require("../utils");

var _constant = require("../constant");

function handleRefLabel(expression, scope, options, onSuccess) {
  var _options$stateFactory = options.stateFactory,
      stateFactory = _options$stateFactory === void 0 ? _constant.DefaultStateFactory : _options$stateFactory;

  if (!(0, _types.isAssignmentExpression)(expression)) {
    throw new Error("ref sugar expression must be an assignment");
  }

  var left = expression.left,
      right = expression.right;

  if (!(0, _types.isIdentifier)(left)) {
    throw new Error("ref sugar assignment left must be an identifier");
  }

  var refItem = {
    scope: scope,
    identify: left,
    modifier: scope.generateUidIdentifier("set".concat((0, _utils.capitalize)(left.name)))
  };
  onSuccess((0, _types.variableDeclaration)("const", [(0, _types.variableDeclarator)((0, _types.arrayPattern)([refItem.identify, refItem.modifier]), (0, _types.callExpression)((0, _types.identifier)(stateFactory), [right]))]), refItem);
}