"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = handleWatchLabel;

var _types = require("@babel/types");

var _constant = require("../constant");

function handleWatchLabel(expression, scope, options, onSuccess) {
  var _options$memoFactory = options.memoFactory,
      memoFactory = _options$memoFactory === void 0 ? _constant.DefaultMemoFactory : _options$memoFactory,
      _options$effectFactor = options.effectFactory,
      effectFactory = _options$effectFactor === void 0 ? _constant.DefaultEffectFactory : _options$effectFactor;

  if (!(0, _types.isAssignmentExpression)(expression) && !(0, _types.isArrowFunctionExpression)(expression)) {
    throw new Error("watch sugar must be an assignment or arrow function");
  }

  if ((0, _types.isArrowFunctionExpression)(expression)) {
    // useEffect
    if (!validateArrowDeps(expression.params)) throw new Error("watch sugar arrow deps can only be identify");
    onSuccess((0, _types.callExpression)((0, _types.identifier)(effectFactory), [(0, _types.arrowFunctionExpression)([], expression.body), (0, _types.arrayExpression)(expression.params)]));
  } else {
    // useMemo
    if (!(0, _types.isArrowFunctionExpression)(expression.right)) {
      throw new Error("watch sugar assign right must be an arrow function");
    }

    if (!(0, _types.isIdentifier)(expression.left)) {
      throw new Error("watch sugar assign left must be an identify");
    }

    if (!validateArrowDeps(expression.right.params)) throw new Error("watch sugar arrow deps can only be identify");
    onSuccess((0, _types.variableDeclaration)("const", [(0, _types.variableDeclarator)(expression.left, (0, _types.callExpression)((0, _types.identifier)(memoFactory), [(0, _types.arrowFunctionExpression)([], expression.right.body), (0, _types.arrayExpression)(expression.right.params)]))]));
  }
}

function validateArrowDeps(params) {
  return params.every(function (i) {
    return (0, _types.isIdentifier)(i);
  });
}